const Main = imports.ui.main;
const WorkspaceSwitcherPopup = imports.ui.workspaceSwitcherPopup;
let   wsPopupInjections;

function resetState() {
    wsPopupInjections = {};
}

function injectToFunction(parent, name, func) {
    let origin = parent[name];
    parent[name] = function() {
        let ret;
        ret = origin.apply(this, arguments);
        if (ret === undefined)
            ret = func.apply(this, arguments);
        return ret;
    }

    return origin;
}

function removeInjection(object, injection, name) {
    object[name] = injection[name];
}

function init() {
    // do nothing
}

function enable() {

    resetState();

    wsPopupInjections['_redisplay'] = injectToFunction(WorkspaceSwitcherPopup.WorkspaceSwitcherPopup.prototype, '_redisplay', function () {

        let workArea = Main.layoutManager.getWorkAreaForMonitor(Main.layoutManager.primaryIndex);
        let [, containerNatHeight] = this._container.get_preferred_height(global.screen_width);
        let [, containerNatWidth] = this._container.get_preferred_width(containerNatHeight);
        if (global.workspaceManager.layout_rows !== -1) {
            this._container.x = workArea.x + Math.floor((workArea.width - containerNatWidth) / 2);
            this._container.y = workArea.y + Math.floor((workArea.height - containerNatHeight) - 80);
        }
        else {
            this._container.x = workArea.x + Math.floor((workArea.width - containerNatWidth) - 50);
            this._container.y = workArea.y + Math.floor((workArea.height - containerNatHeight) / 2);
        }
    } );
}

function disable() {

    for (let i in wsPopupInjections) {
        removeInjection(WorkspaceSwitcherPopup.WorkspaceSwitcherPopup.prototype, wsPopupInjections, i);
    }

    resetState();
}
